/* simple-feed-view.vala
 *
 * Copyright (C) 2008 Christian Hergert <chris@dronelabs.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 
 * 02110-1301 USA
 */

#ifndef __SIMPLE_FEED_VIEW_H__
#define __SIMPLE_FEED_VIEW_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS


#define SIMPLE_FEED_VIEW_TYPE_MAIN (simple_feed_view_main_get_type ())
#define SIMPLE_FEED_VIEW_MAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SIMPLE_FEED_VIEW_TYPE_MAIN, SimpleFeedViewMain))
#define SIMPLE_FEED_VIEW_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SIMPLE_FEED_VIEW_TYPE_MAIN, SimpleFeedViewMainClass))
#define SIMPLE_FEED_VIEW_IS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SIMPLE_FEED_VIEW_TYPE_MAIN))
#define SIMPLE_FEED_VIEW_IS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SIMPLE_FEED_VIEW_TYPE_MAIN))
#define SIMPLE_FEED_VIEW_MAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SIMPLE_FEED_VIEW_TYPE_MAIN, SimpleFeedViewMainClass))

typedef struct _SimpleFeedViewMain SimpleFeedViewMain;
typedef struct _SimpleFeedViewMainClass SimpleFeedViewMainClass;
typedef struct _SimpleFeedViewMainPrivate SimpleFeedViewMainPrivate;

struct _SimpleFeedViewMain {
	GObject parent_instance;
	SimpleFeedViewMainPrivate * priv;
};

struct _SimpleFeedViewMainClass {
	GObjectClass parent_class;
};


SimpleFeedViewMain* simple_feed_view_main_construct (GType object_type);
SimpleFeedViewMain* simple_feed_view_main_new (void);
GType simple_feed_view_main_get_type (void);


G_END_DECLS

#endif
